'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = getDocFile;
var jsdoc = require('jsdoc-api');

function getDocFile(jscodeReqest, file) {
	try {
		var docReturn = jsdoc.explainSync({ source: jscodeReqest }).filter(function (obj) {
			return obj.undocumented !== true;
		}).map(function (obj) {
			if (obj.meta) {
				obj.meta.filename = file;
				obj.meta.path = file;
			} else {
				obj.files[0] = file;
			}
			return obj;
		});
		return docReturn;
	} catch (e) {
		console.log('error', e);
		return;
	}
}