'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

exports.default = getProp;

var _variables = require('./variables');

var _processTags = require('./processTags');

var _processTags2 = _interopRequireDefault(_processTags);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getTypeName(prop) {
	if (!prop) return _variables.UNDEFINED;
	if (Array.isArray(prop)) {
		return prop.map(getTypeNameToFunction).join('|');
	} else {
		return getTypeNameToFunction(prop);
	}
}

function getTypeNameToFunction(object) {
	return object.name.toLowerCase();
}

function getProp(prop, docPart) {
	if (prop) {
		var obj = {};
		if (typeof prop === 'function' || Array.isArray(prop)) {
			obj['type'] = {
				name: getTypeName(prop)
			};
		} else {
			obj['type'] = {
				name: getTypeName(prop.type)
			};
			obj['required'] = prop.required || _variables.EMPTY;
			if (prop.default && typeof prop.default !== 'function') {
				obj['defaultValue'] = {
					value: (0, _stringify2.default)(prop.default),
					computed: false
				};
			}
			obj['tags'] = (0, _processTags2.default)(docPart, _variables.IGNORE_DEFAULT);
			obj['comment'] = (0, _variables.getComment)(docPart);
		}
		obj['description'] = (0, _variables.getDescription)(docPart);
		return obj;
	} else {
		return {
			type: {
				name: _variables.UNDEFINED
			},
			required: false,
			description: _variables.EMPTY,
			tags: {}
		};
	}
}