'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _sandbox = require('./sandbox');

var _sandbox2 = _interopRequireDefault(_sandbox);

var _vm = require('vm');

var _vm2 = _interopRequireDefault(_vm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var babel = require('babel-core');


var babelifyCode = function babelifyCode(code) {
	var options = {
		ast: false,
		comments: false,
		presets: ['babel-preset-es2015']
	};
	return babel.transform(code, options);
};

function clone(obj) {
	if (null == obj || 'object' != (typeof obj === 'undefined' ? 'undefined' : (0, _typeof3.default)(obj))) return obj;
	var copy = obj.constructor();
	for (var attr in obj) {
		if (obj.hasOwnProperty(attr)) copy[attr] = obj[attr];
	}
	return copy;
}

var evalComponentCode = function evalComponentCode(code) {
	var script = new _vm2.default.Script(code, {});
	var sand = clone(_sandbox2.default);
	var context = new _vm2.default.createContext(sand);
	script.runInContext(context);
	return sand.exports;
};

module.exports = function getSandbox(jscodeReqest) {
	var babelifycode = babelifyCode(jscodeReqest);
	return evalComponentCode(babelifycode.code);
};