'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = processMethods;

var _getMethod = require('./getMethod');

var _getMethod2 = _interopRequireDefault(_getMethod);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function processMethods(docFile, component) {
	var listMethods = [];
	(0, _keys2.default)(component.methods).forEach(function (methodName) {
		var docPart = docFile.filter(function (comment) {
			return comment.longname.indexOf('methods.' + methodName) > -1;
		})[0];
		if (docPart) {
			if (docPart['access'] && docPart['access'] === 'public') {
				listMethods.push((0, _getMethod2.default)(methodName, docPart));
			}
		}
	});
	return listMethods;
}