'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = processProps;

var _getProp = require('./getProp');

var _getProp2 = _interopRequireDefault(_getProp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function processProps(docFile, component) {
	if (component.props) {
		var listProps = {};
		if (Array.isArray(component.props)) {
			component.props.forEach(function (propName) {
				listProps[propName] = (0, _getProp2.default)();
			});
		} else {
			(0, _keys2.default)(component.props).forEach(function (key) {
				var propName = key;
				var docPart = docFile.filter(function (comment) {
					return comment.longname.indexOf('props.' + propName) > -1;
				})[0];
				var prop = component.props[propName];
				var listTag = (0, _getProp2.default)(prop, docPart);
				if (listTag['tags'] && !listTag['tags']['ignore']) {
					listProps[propName] = listTag;
				}
			});
		}
		return listProps;
	}
	return;
}